Unit ZCPQLD_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZCPQLG_p, ZCPQLE_p, ZCPQLF_p, ZCPQLL_p, ZCPQLH_p;

procedure ZCPQLD(L3 :Integer; var ZR :Real; var ZI :Real;
                var CONV :Boolean; var RAB :Array of Real);

implementation

procedure ZCPQLD(L3 :Integer; var ZR :Real; var ZI :Real;
                var CONV :Boolean; var RAB :Array of Real);
var
I,J :Integer;
RMP,RMS,RELSTP,TP,R1,R2,OMP :Real;
B,BOOL :Boolean;
const
PT1 :Real = 0.1;
PTO5 :Real = 0.05;
ONE :Real = 1.0;
TWENTY :Real = 20.0;
label
_1,_2,_3,_4,_5,_6,_7;
begin
CONV := False;
B := False;
_PCPQLN.elm1 := ZR;
_PCPQLN.elm2 := ZI;
for I:=1 to L3 do
 begin
  ZCPQLG(_PCPQLN.elm11,_PCPQLN.elm1,_PCPQLN.elm2,RAB[0],RAB[_PP11C.elm1+0],RAB[_PP11C.elm4+0],
       RAB[_PP11C.elm5+0],_PCPQLN.elm5,_PCPQLN.elm6);
  RMP := ZCPQLL(_PCPQLN.elm5,_PCPQLN.elm6);
  RMS := ZCPQLL(_PCPQLN.elm1,_PCPQLN.elm2);
  if ( RMP > TWENTY*ZCPQLH(_PCPQLN.elm11,RAB[_PP11C.elm4+0],RAB[_PP11C.elm5+0],RMS,
       RMP,_PCPQLN.elm7,_PCPQLN.elm8) ) 
   then goto _1;
  CONV := True;
  ZR := _PCPQLN.elm1;
  ZI := _PCPQLN.elm2;
  goto _7;
_1:
  if ( I = 1 ) 
   then goto _4;
  if ( B ) or ( RMP < OMP ) or ( RELSTP >= PTO5 ) 
   then goto _3;
  TP := RELSTP;
  B := True;
  if ( RELSTP < _PCPQLN.elm9 ) 
   then TP := _PCPQLN.elm9;
  R1 := Sqrt(TP);
  R2 := _PCPQLN.elm1*(ONE+R1)-_PCPQLN.elm2*R1;
  _PCPQLN.elm2 := _PCPQLN.elm1*R1+_PCPQLN.elm2*(ONE+R1);
  _PCPQLN.elm1 := R2;
  ZCPQLG(_PCPQLN.elm11,_PCPQLN.elm1,_PCPQLN.elm2,RAB[0],RAB[_PP11C.elm1+0],RAB[_PP11C.elm4+0],
       RAB[_PP11C.elm5+0],_PCPQLN.elm5,_PCPQLN.elm6);
  for J:=1 to 5 do
   begin
    ZCPQLE(BOOL,RAB);
    ZCPQLF(BOOL,RAB);
_2:
   end;
  OMP := _PCPQLN.elm10;
  goto _5;
_3:
  if ( RMP*PT1 > OMP ) 
   then goto _7;
_4:
  OMP := RMP;
_5:
  ZCPQLE(BOOL,RAB);
  ZCPQLF(BOOL,RAB);
  ZCPQLE(BOOL,RAB);
  if ( BOOL ) 
   then goto _6;
  RELSTP := ZCPQLL(_PCPQLN.elm3,_PCPQLN.elm4)/ZCPQLL(_PCPQLN.elm1,_PCPQLN.elm2);
  _PCPQLN.elm1 := _PCPQLN.elm1+_PCPQLN.elm3;
  _PCPQLN.elm2 := _PCPQLN.elm2+_PCPQLN.elm4;
_6:
 end;
_7:
end;

end.
