Unit ZCPQLH_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZCPQLL_p;

function ZCPQLH(NN :Integer; var QR :Array of Real;
                var QI :Array of Real; RMS :Real; RMP :Real;
                ARE :Real; RMRE :Real): Real;

implementation

function ZCPQLH(NN :Integer; var QR :Array of Real;
                var QI :Array of Real; RMS :Real; RMP :Real;
                ARE :Real; RMRE :Real): Real;
var
I :Integer;
E :Real;
label
_1;
begin
{ Result -    ZCPQLH  FORTRANe }
E := ZCPQLL(QR[0],QI[0])*RMRE/(ARE+RMRE);
for I:=1 to NN do
 begin
  E := E*RMS+ZCPQLL(QR[I-1],QI[I-1]);
_1:
 end;
Result := E*(ARE+RMRE)-RMP*RMRE;
exit;
end;

end.
