Unit ZCPQLJ_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function ZCPQLJ(NN :Integer; var PT :Array of Real; REPSR1 :Real;
                RINFP :Real; REPSP :Real; RADIX :Real): Real;

implementation

function ZCPQLJ(NN :Integer; var PT :Array of Real; REPSR1 :Real;
                RINFP :Real; REPSP :Real; RADIX :Real): Real;
var
I,L :Integer;
RHI,RLO,RMAX,RMIN,X,SC :Real;
const
ZERO :Real = 0.0;
HALF :Real = 0.5;
ONE :Real = 1.0;
label
_5,_10,_15,_9005;
begin
{ Result -    ZCPQLJ  FORTRANe }
RHI := Sqrt(RINFP);
RLO := REPSP/REPSR1;
RMAX := ZERO;
RMIN := RINFP;
for I:=1 to NN do
 begin
  X := PT[I-1];
  if ( X > RMAX )
   then RMAX := X;
  if ( X <> ZERO ) and ( X < RMIN )
   then RMIN := X;
_5:
 end;
Result := ONE;
if ( RMIN >= RLO ) and ( RMAX <= RHI )
 then goto _9005;
X := RLO/RMIN;
if ( X > ONE )
 then goto _10;
SC := ONE/(Sqrt(RMAX)*Sqrt(RMIN));
goto _15;
_10:
SC := X;
if ( RINFP/SC < RMAX )
 then SC := ONE;
_15:
L := Trunc( Ln(SC)/Ln(RADIX)+HALF );
Result := IntPower(RADIX,L);
_9005:
exit;
end;

end.
