Unit ZCPQLK_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZCPQLM_p;

procedure ZCPQLK(AR :Real; AI :Real; BR :Real; BI :Real; var CR :Real;
                var CI :Real);

implementation

procedure ZCPQLK(AR :Real; AI :Real; BR :Real; BI :Real; var CR :Real;
                var CI :Real);
var
T,RINFP,R,D :Real;
const
ZERO :Real = 0.0;
ONE :Real = 1.0;
label
_1,_2,_3;
begin
if ( BR <> ZERO ) or ( BI <> ZERO ) 
 then goto _1;
ZCPQLM(T,RINFP,T,T);
CR := RINFP;
CI := RINFP;
goto _3;
_1:
if ( Abs(BR) >= Abs(BI) ) 
 then goto _2;
R := BR/BI;
D := BI+R*BR;
D := ONE/D;
CR := (AR*R+AI)*D;
CI := (AI*R-AR)*D;
goto _3;
_2:
R := BI/BR;
D := BR+R*BI;
D := ONE/D;
CR := (AR+AI*R)*D;
CI := (AI-AR*R)*D;
_3:
end;

end.
