Unit ZCPQLB_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, ZCPQLK_p, ZCPQLL_p;

procedure ZCPQLB(L1 :Integer; var RAB :Array of Real);

implementation

procedure ZCPQLB(L1 :Integer; var RAB :Array of Real);
var
N,NM1,I,I1,I2,I3,JJ,IN_,IN1,IN2,INN,J,T1,T2 :Integer;
ONEDN,XNI :Real;
const
ZERO :Real = 0.0;
TEN :Real = 10.0;
ONE :Real = 1.0;
label
_1,_2,_3,_4,_5;
begin
N := _PCPQLN.elm11-1;
NM1 := N-1;
ONEDN := ONE/(N);
for I:=1 to N do
 begin
  XNI := _PCPQLN.elm11-I;
  I1 := _PP11C.elm2+I;
  I2 := _PP11C.elm3+I;
  I3 := _PP11C.elm1+I;
  RAB[I1-1] := XNI*RAB[I-1]*ONEDN;
  RAB[I2-1] := XNI*RAB[I3-1]*ONEDN;
_1:
 end;
for JJ:=1 to L1 do
 begin
  IN_ := _PP11C.elm2+N;
  IN1 := _PP11C.elm3+N;
  IN2 := _PP11C.elm1+I;
  INN := _PP11C.elm1+N;
  if ( ZCPQLL(RAB[IN_-1],RAB[IN1-1]) <= _PCPQLN.elm9*TEN*
       ZCPQLL(RAB[N-1],RAB[IN2-1]) ) 
   then goto _3;
  INN := _PP11C.elm1+N;
  ZCPQLK(-RAB[_PCPQLN.elm11-1],RAB[INN-1],RAB[IN_-1],RAB[IN1-1],_PCPQLN.elm3,_PCPQLN.elm4);
  for I:=1 to NM1 do
   begin
    J := _PCPQLN.elm11-I;
    I1 := _PP11C.elm2+J;
    I2 := _PP11C.elm3+J;
    I3 := _PP11C.elm1+J;
    T1 := Trunc( RAB[I1-2] );
    T2 := Trunc( RAB[I2-2] );
    RAB[I1-1] := _PCPQLN.elm3*T1-_PCPQLN.elm4*T2+RAB[J-1];
    RAB[I2-1] := _PCPQLN.elm3*T2+_PCPQLN.elm4*T1+RAB[I3-1];
_2:
   end;
  RAB[_PP11C.elm2+0] := RAB[0];
  RAB[_PP11C.elm3+0] := RAB[_PP11C.elm1+0];
  goto _5;
_3:
  for I:=1 to NM1 do
   begin
    J := _PCPQLN.elm11-I;
    I1 := _PP11C.elm2+J;
    I2 := _PP11C.elm3+J;
    RAB[I1-1] := RAB[I1-2];
    RAB[I2-1] := RAB[I2-2];
_4:
   end;
  RAB[_PP11C.elm2+0] := ZERO;
  RAB[_PP11C.elm3+0] := ZERO;
_5:
 end;
end;

end.
