Unit ZCPQLF_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ZCPQLF(BOOL :Boolean; var RAB :Array of Real);

implementation

procedure ZCPQLF(BOOL :Boolean; var RAB :Array of Real);
var
N,J,J1,J2,J3,J4,J5,J6 :Integer;
T1,T2 :Real;
const
ZERO :Real = 0.0;
label
_1,_2,_3,_4;
begin
N := _PCPQLN.elm11-1;
if ( BOOL ) 
 then goto _2;
for J:=2 to N do
 begin
  J1 := _PP11C.elm6+J;
  J2 := _PP11C.elm7+J;
  J3 := _PP11C.elm2+J;
  J4 := _PP11C.elm4+J;
  J5 := _PP11C.elm3+J;
  J6 := _PP11C.elm5+J;
  T1 := RAB[J1-2];
  T2 := RAB[J2-2];
  RAB[J3-1] := _PCPQLN.elm3*T1-_PCPQLN.elm4*T2+RAB[J4-1];
  RAB[J5-1] := _PCPQLN.elm3*T2+_PCPQLN.elm4*T1+RAB[J6-1];
_1:
 end;
RAB[_PP11C.elm2+0] := RAB[_PP11C.elm4+0];
RAB[_PP11C.elm3+0] := RAB[_PP11C.elm5+0];
goto _4;
_2:
for J:=2 to N do
 begin
  J1 := _PP11C.elm2+J;
  J2 := _PP11C.elm6+J-1;
  J3 := _PP11C.elm3+J;
  J4 := _PP11C.elm7+J-1;
  RAB[J1-1] := RAB[J2-1];
  RAB[J3-1] := RAB[J4-1];
_3:
 end;
RAB[_PP11C.elm2+0] := ZERO;
RAB[_PP11C.elm3+0] := ZERO;
_4:
end;

end.
