Unit ZCPQLG_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure ZCPQLG(NN :Integer; SR :Real; SI :Real;
                var PR :Array of Real; var PI :Array of Real;
                var QR :Array of Real; var QI :Array of Real;
                var PVR :Real; var PVI :Real);

implementation

procedure ZCPQLG(NN :Integer; SR :Real; SI :Real;
                var PR :Array of Real; var PI :Array of Real;
                var QR :Array of Real; var QI :Array of Real;
                var PVR :Real; var PVI :Real);
var
I :Integer;
T :Real;
label
_1;
begin
QR[0] := PR[0];
QI[0] := PI[0];
PVR := QR[0];
PVI := QI[0];
for I:=2 to NN do
 begin
  T := PVR*SR-PVI*SI+PR[I-1];
  PVI := PVR*SI+PVI*SR+PI[I-1];
  PVR := T;
  QR[I-1] := PVR;
  QI[I-1] := PVI;
_1:
 end;
end;

end.
