Unit ZCPQLL_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

function ZCPQLL(CR :Real; CI :Real): Real;

implementation

function ZCPQLL(CR :Real; CI :Real): Real;
var
AR,AI :Real;
const
ONE :Real = 1.0;
SYS030 :Real = 1.4142135623730950488016887242097;
label
_1,_2,_3;
begin
{ Result -    ZCPQLL  FORTRANe }
AR := Abs(CR);
AI := Abs(CI);
if ( AR >= AI ) 
 then goto _1;
Result := AI*Sqrt(ONE+IntPower(AR/AI,2));
goto _3;
_1:
if ( AR <= AI ) 
 then goto _2;
Result := AR*Sqrt(ONE+IntPower(AI/AR,2));
goto _3;
_2:
Result := AR*SYS030;
_3:
exit;
end;

end.
